\documentclass[a4paper,notitlepage,oneside,]{article}
\usepackage[a4paper,margin=2.54cm]{geometry}
\usepackage[T1]{fontenc}
\usepackage[sfdefault,scaled=.85]{FiraSans}
\usepackage{newtxsf}
\usepackage{framed}
%
\usepackage{hyperref}
\usepackage[acronym,toc]{glossaries}
\usepackage{parskip}
\usepackage{graphicx}
\usepackage{tabularx}
\usepackage{float}
\usepackage{enumitem}
\usepackage{fancyhdr}
%
\begin{document}
\frenchspacing
%
\pagestyle{fancyplain}
\renewcommand{\footrulewidth}{0.4pt}
\fancyhf{}
\fancyhf[HLE,HLO]{Experiment 1c - Setup an IGP(IS-IS)}
\fancyhf[HRE,HRO,FRE,FRO]{\thepage}
\fancyhf[FLE,FLO]{DE-CIX Academy}
\fancyhf[FCE,FCO]{BGP for networks who peer}
%
\title{Experiment 1c - Setup an IGP (IS-IS)}
\author{\href{mailto:academy@decix.net}{DE-CIX Academy}}
\date{Version 1.4}
\maketitle
%
\section{Purpose}
An IGP (Interior Gateway Protocol) distributes the interface IP addresses within an Autonomous System. This is needed so iBGP can connect. The advantage of IS-IS is that it runs directly on layer 2 (Ethernet) and is able to distribute both IPv4 and IPv6 addresses.

\section{Network Setup}
\begin{figure}[H]
  \centering
  \includegraphics[width=\linewidth,page=2]{img/01-ibgp-drawings.pdf}
  \caption{Network Setup}
  \label{fig:networksetup}
\end{figure}
Figure \ref{fig:networksetup} shows the network topology for this experiment. All devices are connected in a ring like structure, each device has two neighbors. IS-IS is configured on the interfaces.

\section{Slides}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge Setup IS-IS}
\LARGE
\begin{itemize}
  \item IS-IS means ``Intermediate System -- Intermediate System''
  \item IS-IS is the last leftover from the so-called OSI-protocols
  \item It runs not on top of IPv4 or IPv6, but directly on top of Layer 2 (Ethernet).
\end{itemize}
\vspace{1cm}

\begin{framed}
\begin{verbatim}
  router isis myisis
   net 49.0000.0000.0000.00XX.00

  interface dummy0
   ip router isis myisis
   ipv6 router isis myisis
  interface eth1
   ip router isis myisis
   ipv6 router isis myisis
  interface eth2
   ip router isis myisis
   ipv6 router isis myisis
\end{verbatim}
\end{framed}

\begin{itemize}
  \item For \emph{XX} use your router id (01, 02, \ldots)
  \item Instead of \emph{"myisis"} you can use anything. Just be sure it's always the same.
\end{itemize}

Show commands:
\begin{itemize}
  \item show ip route isis
  \item show ipv6 route isis
  \item show isis summary
  \item show isis interface
  \item show isis neighbor
\end{itemize}
\end{samepage}
%----------------------------------------------------------------

\section{Your Device}
Please now connect to your device and check your IP addresses. The commands you need are \emph{show running} or \emph{show interface}:

\section{Setup IS-IS}
\subsection{To set up IS-IS you need to:}
\begin{itemize}
  \item Start the IS-IS process
  \item Define and configure a router id. Format is \emph{49.nnnn.nnnn.nnnn.nnnn.00}. Just set all ``\emph{n}'' to zero except the last ones, which you set to your router's number. So  configure ``49.0000.0000.0000.00XX.00'' with \emph{XX} being your router number.
  \item Enable IS-IS on network interface where needed
\end{itemize}

\subsection{The commands you need are:}
\begin{description}
  \item[show ip route isis] shows you all IPv4 prefixes routed within IS-IS
  \item[show ipv6 route isis] shows you all IPv6 prefixes routed within IS-IS
  \item[show isis] gives you information about the IS-IS process
  \item[show isis interface] shows details about each interface where IS-IS is running
  \item[show isis neighbor] shows discovered neighbor routers which run IS-IS
\end{description}
Note that unlike with OSPF, the \emph{show} commands do not include the term ``ip''. Thats because IS-IS does not run on top of IP, but runs directly on layer 2.

\subsection{To configure IS-IS in config mode you need:}
\begin{description}
  \item[router isis \emph{<name>}] starts an IS-IS process with name \emph{<name>}. The \emph{<name>} is needed for reference later.
  \item[net \emph{<very long router id>}] needs to be configured manually. Format of the router id is 49.0000.0000.0000.xxxx.00. Instead of \emph{xxxx} put in an unique number. For a more complete explanation see \url{http://www.dummies.com/programming/networking/juniper/is-is-network-protocol-basics/}
  \item[ip router isis \emph{<name>}] enables IS-IS for IPv4 on an interface. The \emph{<name>} must be the same as in the process definition.
  \item[ipv6 router isis \emph{<name>}] enables IS-IS for IPv6 on an interface. Example:
  \begin{verbatim}
    interface eth1
      ip router isis myisis
      ipv6 router isis myisis
  \end{verbatim}
\end{description}

\subsection{Tasks:}
\begin{itemize}
  \item Enable IS-IS on the right, left, and dummy interface for IPv4 and IPv6
  \item Check the routing table after all routers have IS-IS enabled. For this, do a \emph{show ip route isis} and take note which loopback addresses are routed through your left and which through your right interface
  \item Do a \emph{ping} to some of the other loopback addresses.
  \item Do a \emph{traceroute} to the other loopback addresses and take note which way the packets go
  \item Shut down one of your interfaces (command \emph{shutdown} in interface context in config mode), do the same traceroutes again. Has anything changed?
  \item Unshut (command: \emph{no shutdown}) the same interface and try again.
  \item Do all a \emph{show ip route isis}, the one of the participants shuts down one interface. Do all the \emph{show ip route isis} again and note what has changed.
\end{itemize}

\begin{minipage}{\textwidth}
\section{Solution}
\subsection{Solution for FRRouting}
\begin{verbatim}
  router isis myisis
    net 49.0000.0000.0000.00XX.00

  interface dummy0
    ip router isis myisis
    ipv6 router isis myisis

  interface eth1
    ip router isis myisis
    ipv6 router isis myisis

  interface eth2
    ip router isis myisis
    ipv6 router isis myisis
\end{verbatim}

Instead of \emph{XX} use your routers id (you can use anything as long as it is unique within your network).
Instead of \emph{myisis} you can use any name for your IS-IS process.
\end{minipage}

\begin{minipage}{\textwidth}
\subsection{Solution for Juniper}
\begin{verbatim}
interfaces {
  em0 {
    unit 0 {
      family iso;
    }
  }
  em1 {
    unit 0 {
      family iso;
    }
  }
  lo0 {
    unit 0 {
      family iso {
        address 49.0000.0000.0000.00XX.00;
      }
    }
  }
}
protocols {
  isis {
        interface em0.0;
        interface em1.0;
        interface lo0.0;
    }
}
\end{verbatim}
\end{minipage}

\begin{minipage}{\textwidth}
\subsection{Solution for Mikrotik}
Mikrotik does not support IS-IS.
\end{minipage}

\end{document}
